Index: /trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py
===================================================================
--- /trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py	(revision 77339)
+++ /trunk/src/VBox/ValidationKit/tests/additions/tdAddGuestCtrl.py	(revision 77340)
@@ -376,8 +376,8 @@
     def getAccessMode(self):
         """ Converts open mode to access mode enum. """
-        if self.sOpenMode == 'r':  return vboxcon.FileOpenMode_ReadOnly;
-        if self.sOpenMode == 'w':  return vboxcon.FileOpenMode_WriteOnly;
-        if self.sOpenMode == 'w+': return vboxcon.FileOpenMode_ReadWrite;
-        if self.sOpenMode == 'r+': return vboxcon.FileOpenMode_ReadWrite;
+        if self.sOpenMode == 'r':  return vboxcon.FileAccessMode_ReadOnly;
+        if self.sOpenMode == 'w':  return vboxcon.FileAccessMode_WriteOnly;
+        if self.sOpenMode == 'w+': return vboxcon.FileAccessMode_ReadWrite;
+        if self.sOpenMode == 'r+': return vboxcon.FileAccessMode_ReadWrite;
         raise base.GenError(self.sOpenMode);
 
@@ -1058,10 +1058,9 @@
         reporter.testDone(fSkip);
 
-        # FIXME: Failing tests.
-        # reporter.testStart('File read');
-        # fSkip = 'file_read' not in self.asTests or fRc is False;
-        # if fSkip is False:
-        #     fRc, oTxsSession = self.testGuestCtrlFileRead(oSession, oTxsSession, oTestVm);
-        # reporter.testDone(fSkip);
+        reporter.testStart('File read');
+        fSkip = 'file_read' not in self.asTests or fRc is False;
+        if fSkip is False:
+            fRc, oTxsSession = self.testGuestCtrlFileRead(oSession, oTxsSession, oTestVm);
+        reporter.testDone(fSkip);
 
         # reporter.testStart('File write');
@@ -3006,5 +3005,5 @@
         aaTests.extend([
             # Write to a non-existing file.
-            [ tdTestFileReadWrite(sUser = sUser, sPassword = sPassword, sFile = sScratch + 'testGuestCtrlFileWrite.txt', \
+            [ tdTestFileReadWrite(sUser = sUser, sPassword = sPassword, sFile = sScratch + 'testGuestCtrlFileWrite.txt',
                                   sOpenMode = 'w+', sDisposition = 'ce', cbToReadWrite = cScratchBuf,
                                   aBuf = aScratchBuf),
@@ -3016,5 +3015,5 @@
         aaTests.extend([
             # Append the same amount of data to the just created file.
-            [ tdTestFileReadWrite(sUser = sUser, sPassword = sPassword, sFile = sScratch + 'testGuestCtrlFileWrite.txt', \
+            [ tdTestFileReadWrite(sUser = sUser, sPassword = sPassword, sFile = sScratch + 'testGuestCtrlFileWrite.txt',
                                   sOpenMode = 'w+', sDisposition = 'oa', cbToReadWrite = cScratchBuf,
                                   cbOffset = cScratchBuf, aBuf = aScratchBuf2),
@@ -3027,5 +3026,5 @@
             curTest = aTest[0]; # tdTestFileReadWrite, use an index, later.
             curRes  = aTest[1]; # tdTestResult
-            reporter.log('Testing #%d, sFile="%s", cbToReadWrite=%d, sOpenMode="%s", sDisposition="%s", cbOffset=%d ...' %
+            reporter.log('Testing #%d, sFile="%s", cbToReadWrite=%d, sOpenMode="%s", sDisposition="%s", cbOffset=%d ...' % \
                          (i, curTest.sFile, curTest.cbToReadWrite, curTest.sOpenMode, curTest.sDisposition, curTest.cbOffset));
             curTest.setEnvironment(oSession, oTxsSession, oTestVm);
@@ -3047,5 +3046,5 @@
                     resOffset = long(curTest.cbOffset);
                     if curOffset != resOffset:
-                        reporter.error('Test #%d failed: Initial offset on open does not match: Got %d, expected %d'
+                        reporter.error('Test #%d failed: Initial offset on open does not match: Got %d, expected %d' \
                                        % (i, curOffset, resOffset));
                         fRc = False;
@@ -3063,5 +3062,5 @@
                     if    curRes.cbProcessed > 0 \
                       and curRes.cbProcessed != cBytesWritten:
-                        reporter.error('Test #%d failed: Written buffer length does not match: Got %d, expected %d'
+                        reporter.error('Test #%d failed: Written buffer length does not match: Got %d, expected %d' \
                                        % (i, cBytesWritten, curRes.cbProcessed));
                         fRc = False;
@@ -3078,5 +3077,5 @@
                             fRc = False;
                         if fRc and long(curFile.offset) != curTest.cbOffset:
-                            reporter.error('Test #%d failed: Initial write position does not match current position, '
+                            reporter.error('Test #%d failed: Initial write position does not match current position, ' \
                                            'got %d, expected %d' % (i, long(curFile.offset), curTest.cbOffset));
                             fRc = False;
@@ -3084,5 +3083,5 @@
                         aBufRead = curFile.read(curTest.cbToReadWrite, 30 * 1000);
                         if len(aBufRead) != curTest.cbToReadWrite:
-                            reporter.error('Test #%d failed: Got buffer length %d, expected %d'
+                            reporter.error('Test #%d failed: Got buffer length %d, expected %d' \
                                            % (i, len(aBufRead), curTest.cbToReadWrite));
                             fRc = False;
@@ -3090,5 +3089,5 @@
                           and curRes.aBuf is not None \
                           and curRes.aBuf != aBufRead:
-                            reporter.error('Test #%d failed: Got buffer\n%s, expected\n%s'
+                            reporter.error('Test #%d failed: Got buffer\n%s, expected\n%s' \
                                            % (i, aBufRead, curRes.aBuf));
                             fRc = False;
@@ -3097,5 +3096,5 @@
                 resOffset = long(curRes.cbOffset);
                 if curOffset != resOffset:
-                    reporter.error('Test #%d failed: Final offset does not match: Got %d, expected %d'
+                    reporter.error('Test #%d failed: Final offset does not match: Got %d, expected %d' \
                                    % (i, curOffset, resOffset));
                     fRc = False;