Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 77346)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.cpp	(revision 77347)
@@ -35,6 +35,7 @@
 
 UIChooserItemGlobal::UIChooserItemGlobal(UIChooserItem *pParent,
+                                         bool fFavorite,
                                          int iPosition /* = -1 */)
-    : UIChooserItem(pParent, false /* favorite? */, pParent->isTemporary(), 0, 100)
+    : UIChooserItem(pParent, fFavorite, pParent->isTemporary(), 0, 100)
     , m_iPosition(iPosition)
     , m_iDefaultLightnessMin(0)
@@ -52,7 +53,8 @@
 
 UIChooserItemGlobal::UIChooserItemGlobal(UIChooserItem *pParent,
+                                         bool fFavorite,
                                          UIChooserItemGlobal *pCopyFrom,
                                          int iPosition /* = -1 */)
-    : UIChooserItem(pParent, false /* favorite? */, pParent->isTemporary(), 0, 100)
+    : UIChooserItem(pParent, fFavorite, pParent->isTemporary(), 0, 100)
     , m_iPosition(iPosition)
     , m_iDefaultLightnessMin(0)
@@ -390,5 +392,5 @@
     /* Add item to the parent: */
     AssertPtrReturnVoid(parentItem());
-    parentItem()->addItem(this, false, m_iPosition);
+    parentItem()->addItem(this, isFavorite(), m_iPosition);
 
     /* Configure connections: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 77346)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserItemGlobal.h	(revision 77347)
@@ -42,8 +42,8 @@
     enum { Type = UIChooserItemType_Global };
 
-    /** Constructs item with specified @a iPosition, passing @a pParent to the base-class. */
-    UIChooserItemGlobal(UIChooserItem *pParent, int iPosition = -1);
-    /** Constructs temporary item with specified @a iPosition as a @a pCopyFrom, passing @a pParent to the base-class. */
-    UIChooserItemGlobal(UIChooserItem *pParent, UIChooserItemGlobal *pCopyFrom, int iPosition = -1);
+    /** Constructs possible @a fFavorite item with specified @a iPosition, passing @a pParent to the base-class. */
+    UIChooserItemGlobal(UIChooserItem *pParent, bool fFavorite, int iPosition = -1);
+    /** Constructs possible @a fFavorite temporary item with specified @a iPosition as a @a pCopyFrom, passing @a pParent to the base-class. */
+    UIChooserItemGlobal(UIChooserItem *pParent, bool fFavorite, UIChooserItemGlobal *pCopyFrom, int iPosition = -1);
     /** Destructs global item. */
     virtual ~UIChooserItemGlobal() /* override */;
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 77346)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.cpp	(revision 77347)
@@ -1854,4 +1854,32 @@
 }
 
+bool UIChooserModel::isGlobalItemFavorite(UIChooserItem *pParentItem) const
+{
+    /* Read group definitions: */
+    const QStringList definitions = gEDataManager->selectorWindowGroupsDefinitions(pParentItem->fullName());
+    /* Return 'false' if no definitions found: */
+    if (definitions.isEmpty())
+        return false;
+
+    /* Prepare required group definition reg-exp: */
+    const QString strDefinitionTemplate = QString("n(\\S)*=GLOBAL");
+    const QRegExp definitionRegExp(strDefinitionTemplate);
+    /* For each the group definition: */
+    foreach (const QString &strDefinition, definitions)
+    {
+        /* Check if this is required definition: */
+        if (definitionRegExp.indexIn(strDefinition) == 0)
+        {
+            /* Get group descriptor: */
+            const QString strDescriptor(definitionRegExp.cap(1));
+            if (strDescriptor.contains('f'))
+                return true;
+        }
+    }
+
+    /* Return 'false' by default: */
+    return false;
+}
+
 UIChooserItem *UIChooserModel::getGroupItem(const QString &strName, UIChooserItem *pParentItem, bool fAllGroupsOpened)
 {
@@ -2016,5 +2044,5 @@
 {
     /* Create global-item: */
-    new UIChooserItemGlobal(pParentItem, 0);
+    new UIChooserItemGlobal(pParentItem, isGlobalItemFavorite(pParentItem), 0);
 }
 
@@ -2203,8 +2231,14 @@
     /* Prepare extra-data key for current group: */
     const QString strExtraDataKey = pParentItem->fullName();
+    /* Iterate over all the global-items: */
+    foreach (UIChooserItem *pItem, pParentItem->items(UIChooserItemType_Global))
+    {
+        const QString strGlobalDescriptor(pItem->isFavorite() ? "nf" : "n");
+        orders[strExtraDataKey] << QString("%1=GLOBAL").arg(strGlobalDescriptor);
+    }
     /* Iterate over all the group-items: */
     foreach (UIChooserItem *pItem, pParentItem->items(UIChooserItemType_Group))
     {
-        QString strGroupDescriptor(pItem->toGroupItem()->isOpened() ? "go" : "gc");
+        const QString strGroupDescriptor(pItem->toGroupItem()->isOpened() ? "go" : "gc");
         orders[strExtraDataKey] << QString("%1=%2").arg(strGroupDescriptor, pItem->name());
         gatherGroupOrders(orders, pItem);
Index: trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 77346)
+++ trunk/src/VBox/Frontends/VirtualBox/src/manager/chooser/UIChooserModel.h	(revision 77347)
@@ -412,4 +412,7 @@
         void cleanupGroupTree(UIChooserItem *pParentItem);
 
+        /** Returns whether global item within the @a pParentItem is favorite. */
+        bool isGlobalItemFavorite(UIChooserItem *pParentItem) const;
+
         /** Acquires group item, creates one if necessary.
           * @param  strName           Brings the name of group we looking for.