Index: /trunk/src/VBox/Additions/common/VBoxGuest/linux/Makefile
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuest/linux/Makefile	(revision 77396)
+++ /trunk/src/VBox/Additions/common/VBoxGuest/linux/Makefile	(revision 77397)
@@ -130,17 +130,25 @@
 endif
 
-MOD_DEFS = -DVBOX -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 -DIN_GUEST \
-           -DIN_GUEST_R0 -DIN_MODULE -DRT_WITH_VBOX -DVBGL_VBOXGUEST \
-           -DVBOX_WITH_HGCM
+MOD_DEFS = \
+	VBOX \
+	RT_OS_LINUX \
+	IN_RING0 \
+	IN_RT_R0 \
+	IN_GUEST \
+	IN_GUEST_R0 \
+	IN_MODULE \
+	RT_WITH_VBOX \
+	VBGL_VBOXGUEST \
+	VBOX_WITH_HGCM
 ifeq ($(BUILD_TARGET_ARCH),amd64)
-MOD_DEFS += -DRT_ARCH_AMD64
+MOD_DEFS += RT_ARCH_AMD64
 else
-MOD_DEFS += -DRT_ARCH_X86
+MOD_DEFS += RT_ARCH_X86
 endif
 ifeq ($(BUILD_TARGET_ARCH),amd64)
-MOD_DEFS += -DVBOX_WITH_64_BITS_GUESTS
+MOD_DEFS += VBOX_WITH_64_BITS_GUESTS
 endif
 ifeq ($(KERN_VERSION),24)
-MOD_DEFS += -DEXPORT_SYMTAB
+MOD_DEFS += EXPORT_SYMTAB
 endif
 
Index: /trunk/src/VBox/Additions/linux/sharedfolders/Makefile.module
===================================================================
--- /trunk/src/VBox/Additions/linux/sharedfolders/Makefile.module	(revision 77396)
+++ /trunk/src/VBox/Additions/linux/sharedfolders/Makefile.module	(revision 77397)
@@ -53,18 +53,18 @@
 	-I$(VBOXSF_DIR)r0drv/linux
 MOD_DEFS = \
-	-DRT_OS_LINUX \
-	-DIN_RING0 \
-	-DIN_RT_R0 \
-	-DIN_SUP_R0 \
-	-DVBOX \
-	-DVBOX_WITH_HGCM \
-	-DIN_MODULE \
-	-DIN_GUEST \
-	-DIN_GUEST_R0 \
-	-DRT_NO_EXPORT_SYMBOL
+	RT_OS_LINUX \
+	IN_RING0 \
+	IN_RT_R0 \
+	IN_SUP_R0 \
+	VBOX \
+	VBOX_WITH_HGCM \
+	IN_MODULE \
+	IN_GUEST \
+	IN_GUEST_R0 \
+	RT_NO_EXPORT_SYMBOL
 ifeq ($(BUILD_TARGET_ARCH),amd64)
-MOD_DEFS += -DRT_ARCH_AMD64 -DVBOX_WITH_64_BITS_GUESTS
+MOD_DEFS += RT_ARCH_AMD64 VBOX_WITH_64_BITS_GUESTS
 else
-MOD_DEFS += -DRT_ARCH_X86
+MOD_DEFS += RT_ARCH_X86
 endif
 ifeq ($(KERN_VERSION),24)
Index: /trunk/src/VBox/HostDrivers/Support/linux/Makefile
===================================================================
--- /trunk/src/VBox/HostDrivers/Support/linux/Makefile	(revision 77396)
+++ /trunk/src/VBox/HostDrivers/Support/linux/Makefile	(revision 77397)
@@ -146,28 +146,23 @@
 endif
 MOD_DEFS = \
-	-DRT_OS_LINUX \
-	-DIN_RING0 \
-	-DIN_RT_R0 \
-	-DIN_SUP_R0 \
-	-DVBOX \
-	-DRT_WITH_VBOX \
-	-DVBOX_WITH_HARDENING \
-	-DSUPDRV_WITH_RELEASE_LOGGER \
-	-DVBOX_WITH_EFLAGS_AC_SET_IN_VBOXDRV \
-	-DIPRT_WITH_EFLAGS_AC_PRESERVING \
-	-DVBOX_WITH_64_BITS_GUESTS # <-- must be consistent with Config.kmk!
+	RT_OS_LINUX \
+	IN_RING0 \
+	IN_RT_R0 \
+	IN_SUP_R0 \
+	VBOX \
+	RT_WITH_VBOX \
+	VBOX_WITH_HARDENING \
+	SUPDRV_WITH_RELEASE_LOGGER \
+	VBOX_WITH_EFLAGS_AC_SET_IN_VBOXDRV \
+	IPRT_WITH_EFLAGS_AC_PRESERVING \
+	VBOX_WITH_64_BITS_GUESTS # <-- must be consistent with Config.kmk!
 ifndef CONFIG_VBOXDRV_FIXEDMAJOR
-MOD_DEFS += -DCONFIG_VBOXDRV_AS_MISC
+MOD_DEFS += CONFIG_VBOXDRV_AS_MISC
 endif
 ifdef VBOX_WITH_NATIVE_DTRACE
-MOD_DEFS += -DVBOX_WITH_NATIVE_DTRACE
-endif
-ifeq ($(BUILD_TARGET_ARCH),amd64)
-MOD_DEFS += -DRT_ARCH_AMD64
-else
-MOD_DEFS += -DRT_ARCH_X86
+MOD_DEFS += VBOX_WITH_NATIVE_DTRACE
 endif
 ifdef VBOX_WITH_TEXT_MODMEM_HACK
-MOD_DEFS += -DRTMEMALLOC_EXEC_HEAP -DVBOX_WITH_TEXT_MODMEM_HACK
+MOD_DEFS += RTMEMALLOC_EXEC_HEAP VBOX_WITH_TEXT_MODMEM_HACK
 endif
 MOD_CFLAGS = -include $(VBOXDRV_DIR)include/VBox/SUPDrvMangling.h \
Index: /trunk/src/VBox/HostDrivers/VBoxNetAdp/linux/Makefile
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetAdp/linux/Makefile	(revision 77396)
+++ /trunk/src/VBox/HostDrivers/VBoxNetAdp/linux/Makefile	(revision 77397)
@@ -51,17 +51,12 @@
 	-I$(VBOXNETADPT_DIR)r0drv/linux
 MOD_DEFS = \
-	-DRT_OS_LINUX \
-	-DIN_RING0 \
-	-DIN_RT_R0 \
-	-DIN_SUP_R0 \
-	-DVBOX \
-	-DRT_WITH_VBOX \
-	-DVBOX_WITH_HARDENING
-ifeq ($(BUILD_TARGET_ARCH),amd64)
- MOD_DEFS += -DRT_ARCH_AMD64
-else
- MOD_DEFS += -DRT_ARCH_X86
-endif
-MOD_DEFS += -DVBOX_WITH_64_BITS_GUESTS # <-- must be consistent with Config.kmk!
+	RT_OS_LINUX \
+	IN_RING0 \
+	IN_RT_R0 \
+	IN_SUP_R0 \
+	VBOX \
+	RT_WITH_VBOX \
+	VBOX_WITH_HARDENING \
+	VBOX_WITH_64_BITS_GUESTS # <-- must be consistent with Config.kmk!
 MOD_CFLAGS = -include $(KBUILD_EXTMOD)/include/VBox/SUPDrvMangling.h -fno-pie -Wno-declaration-after-statement
 
Index: /trunk/src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile	(revision 77396)
+++ /trunk/src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile	(revision 77397)
@@ -54,16 +54,16 @@
 	-I$(VBOXNETFLT_DIR)r0drv/linux
 MOD_DEFS = \
-	-DRT_OS_LINUX \
-	-DIN_RING0 \
-	-DIN_RT_R0 \
-	-DIN_SUP_R0 \
-	-DVBOX \
-	-DRT_WITH_VBOX \
-	-DVBOX_WITH_HARDENING \
-	-DVBOX_WITH_64_BITS_GUESTS # <-- must be consistent with Config.kmk!
+	RT_OS_LINUX \
+	IN_RING0 \
+	IN_RT_R0 \
+	IN_SUP_R0 \
+	VBOX \
+	RT_WITH_VBOX \
+	VBOX_WITH_HARDENING \
+	VBOX_WITH_64_BITS_GUESTS # <-- must be consistent with Config.kmk!
 ifeq ($(BUILD_TARGET_ARCH),amd64)
-MOD_DEFS += -DRT_ARCH_AMD64
+MOD_DEFS += RT_ARCH_AMD64
 else
-MOD_DEFS += -DRT_ARCH_X86
+MOD_DEFS += RT_ARCH_X86
 endif
 MOD_CFLAGS = -include $(VBOXNETFLT_DIR)include/VBox/SUPDrvMangling.h -fno-pie -Wno-declaration-after-statement
Index: /trunk/src/VBox/HostDrivers/VBoxPci/linux/Makefile
===================================================================
--- /trunk/src/VBox/HostDrivers/VBoxPci/linux/Makefile	(revision 77396)
+++ /trunk/src/VBox/HostDrivers/VBoxPci/linux/Makefile	(revision 77397)
@@ -55,16 +55,11 @@
 	-I$(VBOXPCI_DIR)r0drv/linux
 MOD_DEFS = \
-	-DRT_OS_LINUX \
-	-DIN_RING0 \
-	-DIN_RT_R0 \
-	-DIN_SUP_R0 \
-	-DVBOX \
-	-DRT_WITH_VBOX \
-	-DVBOX_WITH_HARDENING
-ifeq ($(BUILD_TARGET_ARCH),amd64)
-MOD_DEFS += -DRT_ARCH_AMD64
-else
-MOD_DEFS += -DRT_ARCH_X86
-endif
+	RT_OS_LINUX \
+	IN_RING0 \
+	IN_RT_R0 \
+	IN_SUP_R0 \
+	VBOX \
+	RT_WITH_VBOX \
+	VBOX_WITH_HARDENING
 MOD_CFLAGS = -include $(VBOXPCI_DIR)include/VBox/SUPDrvMangling.h -fno-pie
 
Index: /trunk/src/VBox/Installer/linux/Makefile-footer.gmk
===================================================================
--- /trunk/src/VBox/Installer/linux/Makefile-footer.gmk	(revision 77396)
+++ /trunk/src/VBox/Installer/linux/Makefile-footer.gmk	(revision 77397)
@@ -36,5 +36,11 @@
 VBOX_INCL := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL)) $(MOD_INCL)
 
-KFLAGS   := -D__KERNEL__ -DMODULE -DRT_WITHOUT_PRAGMA_ONCE $(MOD_DEFS)
+KFLAGS := -D__KERNEL__ -DMODULE -DRT_WITHOUT_PRAGMA_ONCE $(addprefix -D,$(MOD_DEFS))
+ifeq ($(BUILD_TARGET_ARCH),amd64)
+KFLAGS += -DRT_ARCH_AMD64
+else
+KFLAGS += -DRT_ARCH_X86
+endif
+
 ifeq ($(BUILD_TYPE),debug)
 # The -Wno-array-bounds is because of a bug in gcc 4.something, see
Index: /trunk/src/VBox/Installer/linux/Makefile-header.gmk
===================================================================
--- /trunk/src/VBox/Installer/linux/Makefile-header.gmk	(revision 77396)
+++ /trunk/src/VBox/Installer/linux/Makefile-header.gmk	(revision 77397)
@@ -27,6 +27,5 @@
 # follows:
 #
-# # Linux kbuild sets this to our source directory if we are called from
-# # there
+# # Linux kbuild sets this to our source directory if we are called from there
 # obj ?= $(CURDIR)
 # include $(obj)/Makefile-header.gmk